#define _GNU_SOURCE
#include<stdio.h>
#include<pthread.h>
#include"../../../nfs_for_tegra3/papi-5.2.0/src/papi.h"
#include<stdlib.h>
#include "../ARM_tlb_malloc/tlb_malloc.h"
#include<sched.h>
#include<sys/resource.h>
#include<errno.h>
#include<sys/mman.h>
#define NO_OF_EVENTS_LOW 2
#define thread1_no_of_jobs  48 
#define thread2_no_of_jobs  6 
//#define NORMAL_MALLOC 1
#define TLB_MALLOC 1
#define PAGES_PER_THREAD 64
struct timeval thread1_start_time, thread2_start_time;

//thread 1 variables
long long thread1_load_L1_miss_L2_miss [thread1_no_of_jobs + 1]; //plus one to store the initial misses at loc 0
long long thread1_load_L1_miss_L2_hit [thread1_no_of_jobs + 1];
long long thread1_store_L1_miss_L2_miss [thread1_no_of_jobs + 1];
long long thread1_store_L1_miss_L2_hit [thread1_no_of_jobs + 1];
unsigned long long thread1_exec_cycles [thread1_no_of_jobs + 1];
//volatile int *thread1_alloc_list[PAGES_PER_THREAD];
volatile int **thread1_alloc_list = NULL;

//thread 2 variables
long long thread2_load_L1_miss_L2_miss [thread2_no_of_jobs + 1]; //plus one to store the initial misses at loc 0
long long thread2_load_L1_miss_L2_hit [thread2_no_of_jobs + 1];
long long thread2_store_L1_miss_L2_miss [thread2_no_of_jobs + 1];
long long thread2_store_L1_miss_L2_hit [thread2_no_of_jobs + 1];
unsigned long long thread2_exec_cycles [thread2_no_of_jobs + 1];
//volatile int *thread2_alloc_list[PAGES_PER_THREAD];
volatile int **thread2_alloc_list = NULL;

volatile int thread1_done = 0;
volatile int thread2_done = 0;
volatile int mappings[64];

pthread_mutex_t thread2_proceed_mutex;
pthread_cond_t thread2_proceed_cv;
pthread_mutex_t thread1_proceed_mutex;
pthread_cond_t thread1_proceed_cv;

int thread1_proceed = 0;
int thread2_proceed = 0;


#define CALL( exp ) do { \
	int ret; \
	ret = exp; \
	if (ret != 0) {\
		fprintf(stderr, "%s failed: %m\n", #exp);\
		exit(1);\
	}\
	else \
	fprintf(stderr, "%s ok.\n", #exp); \
} while (0)

void find_mappings();
void print_mappings();
volatile int ** get_access_list(char * thread_name);
long gettime(struct timeval start, struct timeval end)
{
	long duration;
	long microsecond = 1000000;
	if (end.tv_usec < start.tv_usec)
	{
		long elapsed_microseconds = microsecond - start.tv_usec + end.tv_usec;
		long elapsed_seconds = (end.tv_sec - start.tv_sec) - 1;
		duration = elapsed_seconds * microsecond + elapsed_microseconds;
	}
	else
	{
		duration = ((end.tv_sec - start.tv_sec) * microsecond) + (end.tv_usec - start.tv_usec);
	}
	return duration;
}


void gettimediff(struct timeval *dst, struct timeval start, struct timeval end)
{

	dst -> tv_sec = start.tv_sec - end.tv_sec;
	dst -> tv_usec = start.tv_usec - end.tv_usec;
	if ( dst -> tv_sec < 0 )
		dst -> tv_sec = 0;
	if ( dst-> tv_usec < 0 )
		dst -> tv_usec = 0;

	/*struct timeval temp = start;
	start = end;
	end = temp;
	long microsecond = 1000000;
	if (end.tv_usec < start.tv_usec)
	{
		long elapsed_microseconds = microsecond - start.tv_usec + end.tv_usec;
		long elapsed_seconds;
		if(end.tv_sec != start.tv_sec)
		{
			elapsed_seconds = (end.tv_sec - start.tv_sec) - 1;
		}
		else
			elapsed_seconds = 0;
		dst->tv_sec = elapsed_seconds;
		dst->tv_usec = elapsed_microseconds;
	}
	else
	{
		dst->tv_sec = end.tv_sec - start.tv_sec;
		dst->tv_usec = end.tv_usec - start.tv_usec;
	}*/

}
/*void gettimediff(struct timeval *dst, struct timeval start, struct timeval end)
{


	if ( ( ( start.tv_sec - end.tv_sec) <= 0) && ( ( start.tv_usec - end.tv_usec) <= 0))
	{
		long microsecond = 1000000;
		if (end.tv_usec < start.tv_usec)
		{
			long elapsed_microseconds = microsecond - start.tv_usec + end.tv_usec;
			long elapsed_seconds;
			if(end.tv_sec != start.tv_sec)
			{
				elapsed_seconds = (end.tv_sec - start.tv_sec) - 1;
			}
			else
				elapsed_seconds = 0;
			dst->tv_sec = elapsed_seconds;
			dst->tv_usec = elapsed_microseconds;
		}
		else
		{
			dst->tv_sec = end.tv_sec - start.tv_sec;
			dst->tv_usec = end.tv_usec - start.tv_usec;
		}
	}
	else
	{
		struct timeval temp = start;
		start = end;
		end = temp;
		long microsecond = 1000000;
		if (end.tv_usec < start.tv_usec)
		{
			long elapsed_microseconds = microsecond - start.tv_usec + end.tv_usec;
			long elapsed_seconds;
			if(end.tv_sec != start.tv_sec)
			{
				elapsed_seconds = (end.tv_sec - start.tv_sec) - 1;
			}
			else
				elapsed_seconds = 0;
			dst->tv_sec = elapsed_seconds;
			dst->tv_usec = elapsed_microseconds;
		}
		else
		{
			dst->tv_sec = end.tv_sec - start.tv_sec;
			dst->tv_usec = end.tv_usec - start.tv_usec;
		}

	}
}*/

void addtime(struct timeval * dst, struct timeval *add_factor)
{

	long microsecond = 1000000;
	if(dst -> tv_usec + add_factor -> tv_usec >= microsecond)
	{

		long rem = dst -> tv_usec + add_factor -> tv_usec - microsecond;
		dst -> tv_sec = dst -> tv_sec + add_factor -> tv_sec + 1;
		dst -> tv_usec = rem;
	}
	else
	{
		dst -> tv_sec = dst -> tv_sec + add_factor -> tv_sec;
		dst -> tv_usec = dst -> tv_usec + add_factor -> tv_usec;
	}
}

	static void
display_pthread_attr(pthread_attr_t *attr, char *prefix)
{
	int s, i;
	size_t v;
	void *stkaddr;
	struct sched_param sp;

	s = pthread_attr_getstack(attr, &stkaddr, &v);
	if (s != 0)
		exit(1);
	printf("%sStack address       = %p\n", prefix, stkaddr);
	printf("%sStack size          = 0x%x bytes\n", prefix, v);
}

void * thread_1_access(void * arg)
{

	struct timeval init_start, init_end;
	gettimeofday(&init_start,NULL); 	

	struct timeval wait, now, release, period, phase; 
	release = thread1_start_time;
	period.tv_sec = 0;
	period.tv_usec = 0.15 * 1000; //2 ms
	pthread_t thread = pthread_self();
	pthread_attr_t gattr;
	struct sched_param param;
	param.sched_priority = 98;
	int ret;
	int job_no = 1;
	int small_block_size_bytes = 3000;
	int small_block_size = small_block_size_bytes / sizeof(int);
	int repetitions = 45; // 70 for linux 3.10 for p=2ms, e = 0.4 ms
	/*printf(" ----- Array address -----\n");
	CALL(pthread_getattr_np(pthread_self(), &gattr));
	display_pthread_attr(&gattr, "1");
	printf("load l1 miss l2 miss: %p\n", &thread1_load_L1_miss_L2_miss[0]);
	printf("load l1 miss l2 hit: %p\n", &thread1_load_L1_miss_L2_hit[0]);
	printf("store l1 miss l2 miss: %p\n", &thread1_store_L1_miss_L2_miss[0]);
	printf("store l1 miss l2 hit: %p\n", &thread1_store_L1_miss_L2_hit[0]);
	printf("thread 1 job_no: %p\n", &job_no);
	printf("small_block_size: %p\n", &small_block_size);
	printf("thread1_done: %p\n", &thread1_done);
	printf("thread1_alloc_list: %p\n", &thread1_alloc_list[0]);
	printf("----------------\n");*/
	/*if( (ret = pthread_setschedparam(thread, SCHED_FIFO, &param)) != 0)
	  {
	  printf("Set sched param failed, %d\n", ret);
	  exit(1);
	  }*/
	long page_no = (long)arg;
	//pthread_t temp = (pthread_t) id;
	int event_set = PAPI_NULL;
	int events_low[NO_OF_EVENTS_LOW];
	long long values_low[NO_OF_EVENTS_LOW];
	long long values_low_dummy[NO_OF_EVENTS_LOW];
	long long values_low_oh[NO_OF_EVENTS_LOW];
	long long values_low_dummy_oh[NO_OF_EVENTS_LOW];
	if(PAPI_register_thread() != PAPI_OK)
	{
		printf("Thread reg failed\n");
		exit(1);

	}

	if(PAPI_create_eventset(&event_set) == PAPI_OK)
	{
		if(PAPI_event_name_to_code("DTLB_MISS_DEP_STALL_CYCLES" , &events_low[0]) == PAPI_OK)
		{
			if(PAPI_event_name_to_code("MICRO_DTLB_MISS_DEP_STALL_CYCLES",&events_low[1])== PAPI_OK)
			{
				//if(PAPI_event_name_to_code("DTLB_STORE_MISSES:MISS_CAUSES_A_WALK", &events_low[2]) == PAPI_OK)
				{
					//if(PAPI_event_name_to_code("DTLB_STORE_MISSES:STLB_HIT", &events_low[3]) == PAPI_OK)
					{
						//if(PAPI_event_name_to_code("L1D:REPLACEMENT", &events_low[3]) == PAPI_OK)
						//{
						//if(PAPI_event_name_to_code("perf::DTLB-STORES", &events_low[5]) == PAPI_OK)
						//{
						if(PAPI_add_events(event_set, events_low, NO_OF_EVENTS_LOW) == PAPI_OK)
						{
						}
						else{
							exit(1);
						}
						//}
						//}
					}
				}
			}

		}
	}


	register int i, j;
	volatile int temp;
	//printf("thread 1 i & j %p %p\n", &i, &j);
	init_tlb_malloc_lib(64, 2, 0, 0, 0 ,0);
	/*#ifdef NORMAL_MALLOC
		for ( i = 0 ; i < PAGES_PER_THREAD; i ++)
		{
			thread1_alloc_list[i] = (int *) malloc(small_block_size_bytes);
		}
	#endif*/
	#ifdef TLB_MALLOC
		const int STATS_MAX_ARRAY_ELEMENTS = 1000;
		int idx = 0;
		int page_color = COLOR_3;
		/*thread1_alloc_list[0] = (int *) tlb_malloc((sizeof(int) * STATS_MAX_ARRAY_ELEMENTS), page_color);
		thread1_alloc_list[1] = (int *) tlb_malloc((sizeof(int) * STATS_MAX_ARRAY_ELEMENTS), page_color);
		thread1_alloc_list[2] = (int *) tlb_malloc((sizeof(int) * STATS_MAX_ARRAY_ELEMENTS), page_color);
		thread1_alloc_list[3] = (int *) tlb_malloc((sizeof(int) * STATS_MAX_ARRAY_ELEMENTS), page_color);
		idx = 4;*/
		page_color = COLOR_4;
		while(idx != (PAGES_PER_THREAD))
		{
			thread1_alloc_list[idx] = (int *) tlb_malloc((sizeof(int) * STATS_MAX_ARRAY_ELEMENTS), page_color);
			if(thread1_alloc_list[idx] != NULL)
			{
				idx++;
				page_color = (page_color + 1) % 64;
				if(page_color == COLOR_4 + 32)
					page_color = COLOR_4;
			}
			else
			{
				page_color = (page_color + 1) % 64;
				if(page_color == COLOR_4 + 32)
					page_color = COLOR_4;
				//if(page_color == 4)
					//page_color = 5;
			}
			//if(idx == PAGES_PER_THREAD)
			//	break;
		}
	#endif
	struct timespec wait_ns;
	struct timeval start_time, end_time;
	unsigned int start_high, start_low, end_high, end_low, base;
	unsigned int cycles_now_high, cycles_now_low;
	//base = FindBase();
	//base = 0;
	volatile int ** access_list = NULL;
	int access_list_length = -1;
	wait_ns.tv_sec = 0;
	wait_ns.tv_nsec = 1000;
	nanosleep(&wait_ns,&wait_ns);
	/*pthread_mutex_lock(&thread1_proceed_mutex);
	while( thread1_proceed != 1)
	{
		pthread_cond_wait(&thread1_proceed_cv, &thread1_proceed_mutex);
		//call find mappings here and then set thread2_proceed
	}
	pthread_mutex_unlock(&thread1_proceed_mutex);*/
		find_mappings();
		print_mappings();
		access_list = get_access_list("t1");
		access_list_length = *access_list[0];
		printf(" T1 Length %d\n",access_list_length);
	#ifdef TLB_MALLOC
	/*access_list = (volatile int **) tlb_malloc(sizeof(int*) * 4, COLOR_0);
	for( i = 0 ; i < 3; i ++)
	{
		access_list[i + 1] = thread1_alloc_list[i];
	}*/
	access_list_length = 2;
	#endif
	for( i = 1 ; i <= access_list_length ; i ++)
	{
		printf("Thread 1 , access_list[%d]: %p\n",i,access_list[i]);
	}
	if(PAPI_start(event_set) != PAPI_OK)
		printf("low level start event error\n");
	if(PAPI_read(event_set, values_low_dummy) != PAPI_OK)
		printf("*******error reading*******\n ");
	//initial access 
	for(j=0; j < PAGES_PER_THREAD ;j++)
	{
		thread1_alloc_list[j][0] = 2;
		//InitSeed_Stats();
		//Initialize_Stats(access_list[j]);
	}
		asm("DMB");
	if(PAPI_read(event_set, values_low) != PAPI_OK)
		printf("*******error reading*******\n ");
	thread1_load_L1_miss_L2_miss[0] = values_low[0] - values_low_dummy[0];
	thread1_load_L1_miss_L2_hit[0] = values_low[1] - values_low_dummy[1];
	//thread1_store_L1_miss_L2_miss[0] = values_low[2] - values_low_dummy[2];
	//thread1_store_L1_miss_L2_hit[0] = values_low[3] - values_low_dummy[3];

	volatile int * small_blk_1 = access_list[1];
	volatile int * small_blk_2 = access_list[2];
	volatile int * small_blk_3 = access_list[3];
	volatile int * small_blk_4 = access_list[4];
	volatile int * small_blk_5 = access_list[5];
	printf("addr of small_blk_1 %p\n",&small_blk_1);
	register volatile int sum1 = 0, sum2 = 0 , sum3 = 0 , sum4 = 0;

	//CALL(mlockall(MCL_CURRENT | MCL_FUTURE));
	gettimeofday(&init_end,NULL);
	printf("Thread 1 init takes %ld\n\n\n",gettime(init_start,init_end)); 	

	//gettimeofday(&release,NULL);
	//addtime(&release,&phase);
	do
	{
		//unsigned long long cycles_to_wait = (2 * 2 * 1000000);
		//unsigned long long cycles_to_wait = (1000);
		//unsigned long long cycles;
		gettimeofday(&now,NULL);
		//GetTimeStamp(&cycles_now_high, &cycles_now_low);
		/*do
		  {
		  unsigned int wait_high, wait_low;
		  GetTimeStamp(&wait_high, &wait_low);
		  cycles = GetNumberOfCycles(cycles_now_high, cycles_now_low, wait_high, wait_low, base);
		  }while(cycles <= cycles_to_wait);*/
	//printf("thread 1, release time %d sec %d mic seconds \n", release.tv_sec, release.tv_usec);
	//printf("thread 1, now time %d sec %d mic seconds \n", now.tv_sec, now.tv_usec);
		gettimediff(&wait, release, now);
		wait_ns.tv_sec = wait.tv_sec;
		wait_ns.tv_nsec = wait.tv_usec * 1000;
		//printf("thread 1,job no %d sleeping for %d sec %d mic seconds \n", job_no,wait.tv_sec, wait.tv_usec);
		nanosleep(&wait_ns,&wait_ns);
		gettimeofday(&start_time,NULL);
		//GetTimeStamp(&start_high, &start_low);
			if(PAPI_read(event_set, values_low_dummy) != PAPI_OK)
				printf("*******error reading*******\n ");

			for ( i = 0 ; i < 130; i ++)
			{
				for ( j = 0 ; j < (PAGES_PER_THREAD); j ++)
				{
					thread1_alloc_list[j][0] = 2;
					asm("DMB;");
				}
			/*	access_list[1][0] = 2;
				asm("DMB;");
				access_list[2][0] = 2;
				asm("DMB;");
				access_list[3][0] = 2;
				asm("DMB;");
				access_list[4][0] = 2;
				asm("DMB;");*/
				/*Initialize_Stats(access_list[1]);
				Initialize_Stats(access_list[2]);
				Initialize_Stats(access_list[3]);
				Initialize_Stats(access_list[4]);
				stats_main(access_list[1],access_list[2]);
				stats_main(access_list[3],access_list[4]);*/
				//stats_main(access_list[4],access_list[4]);*/
			}
			if(PAPI_read(event_set, values_low) != PAPI_OK)
				printf("*******error reading*******\n ");

			thread1_load_L1_miss_L2_miss[job_no] = values_low[0] - values_low_dummy[0];
			thread1_load_L1_miss_L2_hit[job_no] = values_low[1] - values_low_dummy[1];
			//thread1_store_L1_miss_L2_miss[job_no] = values_low[2] - values_low_dummy[2];
			//thread1_store_L1_miss_L2_hit[job_no] = values_low[3] - values_low_dummy[3];


		/*for( i = 0 ; i < (45 * 1023 * 14); i ++)
		{
			asm("nop;");
		}*/
		addtime(&release, &period);
		
		//GetTimeStamp(&end_high, &end_low);
		gettimeofday(&end_time,NULL);
		//thread1_exec_cycles[job_no] = GetNumberOfCycles(start_high, start_low,end_high,end_low,base);
		thread1_exec_cycles[job_no] = gettime(start_time, end_time);
		job_no++;
	}while(job_no <= thread1_no_of_jobs);//while(1);//while(no_of_times != 0);
	thread1_done = 1;
	asm("DMB;");
	if(PAPI_stop(event_set,values_low) != PAPI_OK)
		printf("low level stop event error\n");

}

void * thread_2_access_new(void * arg)
{

	struct timeval init_start, init_end;
	gettimeofday(&init_start,NULL); 	

	struct timeval wait, now, release, period, phase; 
	release = thread2_start_time;
	period.tv_sec = 0;
	period.tv_usec = 16 * 1000; //16 ms
	pthread_t thread = pthread_self();
	pthread_attr_t gattr;
	struct sched_param param;
	param.sched_priority = 98;
	int ret;
	int job_no = 1;
	int small_block_size_bytes = 3000;
	int small_block_size = small_block_size_bytes / sizeof(int);
	int repetitions = 178;  // 950 for linux 2.6.32 for p = 16ms & e = 8ms with gettimeofday 
	int event_set = PAPI_NULL;
	int events_low[NO_OF_EVENTS_LOW];
	long long values_low[NO_OF_EVENTS_LOW];
	long long values_low_dummy[NO_OF_EVENTS_LOW];
	/*printf(" ----- Array address -----\n");
	CALL(pthread_getattr_np(pthread_self(), &gattr));
	display_pthread_attr(&gattr, "2");
	printf("load l1 miss l2 miss: %p\n", &thread2_load_L1_miss_L2_miss[0]);
	printf("load l1 miss l2 hit: %p\n", &thread2_load_L1_miss_L2_hit[0]);
	printf("store l1 miss l2 miss: %p\n", &thread2_store_L1_miss_L2_miss[0]);
	printf("store l1 miss l2 hit: %p\n", &thread2_store_L1_miss_L2_hit[0]);
	printf("thread 2 job_no: %p\n", &job_no);
	printf("small_block_size: %p\n", &small_block_size);
	printf("thread2_done: %p\n", &thread2_done);
	printf("values_low: %p\n", &values_low[0]);
	printf("values_dummy: %p\n", &values_low_dummy[0]);
	printf("small block size: %d\n", small_block_size);
	printf("----------------\n");*/
	long page_no = (long)arg;
	//pthread_t temp = (pthread_t) id;
	/*int val = set_and_init_low();
	  if( val == 0){
	  printf("Init error\n");
	  }*/
	if(PAPI_register_thread() != PAPI_OK)
	{
		printf("Thread reg failed\n");
		exit(1);

	}

	if(PAPI_create_eventset(&event_set) == PAPI_OK)
	{
		if(PAPI_event_name_to_code("DTLB_MISS_DEP_STALL_CYCLES",&events_low[0])== PAPI_OK)
		{
			if(PAPI_event_name_to_code("MICRO_DTLB_MISS_DEP_STALL_CYCLES" , &events_low[1]) == PAPI_OK)
			{
				//if(PAPI_event_name_to_code("DTLB_STORE_MISSES:MISS_CAUSES_A_WALK", &events_low[2]) == PAPI_OK)
				{
					//if(PAPI_event_name_to_code("DTLB_STORE_MISSES:STLB_HIT", &events_low[3]) == PAPI_OK)
					{
						//if(PAPI_event_name_to_code("L1D:REPLACEMENT", &events_low[3]) == PAPI_OK)
						//{
						//if(PAPI_event_name_to_code("perf::DTLB-STORES", &events_low[5]) == PAPI_OK)
						//{
						if(PAPI_add_events(event_set, events_low, NO_OF_EVENTS_LOW) == PAPI_OK)
						{
						}
						else{
							exit(1);
						}
						//}
						//}
					}
				}
			}

		}
	}


	register int i,j;
	volatile int temp;
	//printf("thread 2 i & j %p %p\n", &i, &j);
	init_tlb_malloc_lib(64, 2, 0, 0, 0 ,0);

	/*#ifdef NORMAL_MALLOC
		for ( i = 0 ; i < PAGES_PER_THREAD; i ++)
		{
			thread2_alloc_list[i] = (int *) malloc(small_block_size_bytes);
		}
	#endif*/
	#ifdef TLB_MALLOC
		const int INSERTION_SORT_MAX_ELEMENTS= 1000;
		int idx = 0;
		int page_color = COLOR_11;
		/*thread2_alloc_list[0] = (int *) tlb_malloc((sizeof(int) * INSERTION_SORT_MAX_ELEMENTS), page_color);
		thread2_alloc_list[1] = (int *) tlb_malloc((sizeof(int) * INSERTION_SORT_MAX_ELEMENTS), page_color);
		thread2_alloc_list[2] = (int *) tlb_malloc((sizeof(int) * INSERTION_SORT_MAX_ELEMENTS), page_color);
		thread2_alloc_list[3] = (int *) tlb_malloc((sizeof(int) * INSERTION_SORT_MAX_ELEMENTS), page_color);
		idx = 4;*/
		page_color = COLOR_36;
		while(idx != PAGES_PER_THREAD)
		{
			thread2_alloc_list[idx] = (int *) tlb_malloc((sizeof(int) * INSERTION_SORT_MAX_ELEMENTS), page_color);
			if(thread2_alloc_list[idx] != NULL)
			{
				idx++;
				page_color = (page_color + 1) % 64;
				if(page_color == COLOR_36 + 32)
					page_color = COLOR_36;
			}
			else
			{
				 page_color = (page_color + 1) % 64;
                                if(page_color == COLOR_36 + 32)
                                        page_color = COLOR_36;
                               // if(page_color == 4)
                                 //       page_color = 5;

			}
			//(idx == PAGES_PER_THREAD)
			//reak;
		}
	#endif
	struct timespec wait_ns;
	struct timeval start_time, end_time;
	unsigned int start_high, start_low, end_high, end_low, base;
	unsigned int cycles_now_high, cycles_now_low;
	//base = FindBase();
	volatile int ** access_list = NULL;
	int access_list_length = -1;
	wait_ns.tv_sec = 0;
	wait_ns.tv_nsec = 1000;
	nanosleep(&wait_ns,&wait_ns);

	//pthread_mutex_lock(&thread1_proceed_mutex);
	//call find mappings here
	find_mappings();
	print_mappings();
	access_list = get_access_list("t2");
	access_list_length = *access_list[0];
	//thread1_proceed = 1;
	//asm("DMB;");
	//pthread_cond_signal(&thread1_proceed_cv);
	//pthread_mutex_unlock(&thread1_proceed_mutex);
	//printf(" Thread %d, small block 4 Address: %p\n",page_no + 1, small_blk_4);
	#ifdef TLB_MALLOC
	/*access_list = (volatile int **) tlb_malloc(sizeof(int *) * 4, COLOR_0);
	for( i = 0 ; i < 3; i ++)
	{
		access_list[i+1] = thread2_alloc_list[i];
	}*/
	//access_list_length = 3;
	#endif
	//print_mappings();
	for( i = 1 ; i <= access_list_length ; i ++)
	{
		printf("Thread 2 , access_list[%d]: %p\n",i,access_list[i]);
	}
	if(PAPI_start(event_set) != PAPI_OK)
		printf("low level start event error\n");
	if(PAPI_read(event_set, values_low_dummy) != PAPI_OK)
		printf("*******error reading*******\n ");
	//initial access 
	for(i = 0; i < PAGES_PER_THREAD; i++)
	{
		//*access_list[i] = 2;
		thread2_alloc_list[i][0] = 2;
	}
	asm("DMB;");
	//InitSeed_Insertion();
        //insertion_sort_init(access_list[1]);
        //insertion_sort_init(access_list[2]);
        //insertion_sort_init(access_list[3]);
        //insertion_sort_init(access_list[4]);

	if(PAPI_read(event_set, values_low) != PAPI_OK)
		printf("*******error reading*******\n ");
	thread2_load_L1_miss_L2_miss[0] = values_low[0] - values_low_dummy[0];
	thread2_load_L1_miss_L2_hit[0] = values_low[1] - values_low_dummy[1];
	//thread2_store_L1_miss_L2_miss[0] = values_low[2] - values_low_dummy[2];
	//thread2_store_L1_miss_L2_hit[0] = values_low[3] - values_low_dummy[3];
	//CALL(mlockall(MCL_CURRENT | MCL_FUTURE));
	volatile int * small_blk_1 = access_list[1];
	volatile int * small_blk_2 = access_list[2];
	volatile int * small_blk_3 = access_list[3];
	volatile int * small_blk_4 = access_list[4];
	volatile int * small_blk_5 = access_list[5];

	gettimeofday(&init_end,NULL);
	printf("Thread 2 init takes %ld\n\n\n",gettime(init_start,init_end)); 	

	//gettimeofday(&release,NULL);
	//addtime(&release,&phase);
	//printf("thread 2, release time, %d sec %d mic sec \n", release.tv_sec, release.tv_usec);
	do
	{
		unsigned long long cycles_to_wait = (16 * 2 * 1000000);
		//unsigned long long cycles_to_wait = (1000);
		unsigned long long cycles;
		gettimeofday(&now,NULL);
		//printf("thread 2, now, %d sec %d mic sec \n", now.tv_sec, now.tv_usec);
		//GetTimeStamp(&cycles_now_high, &cycles_now_low);
		/*do
		  {
		  unsigned int wait_high, wait_low;
		  GetTimeStamp(&wait_high, &wait_low);
		  cycles = GetNumberOfCycles(cycles_now_high, cycles_now_low, wait_high, wait_low, base);
		  }while(cycles <= cycles_to_wait);*/
	//printf("thread 2, release time %d sec %d mic seconds \n", release.tv_sec, release.tv_usec);
	//printf("thread 2, now time %d sec %d mic seconds \n", now.tv_sec, now.tv_usec);
		gettimediff(&wait, release, now);
		wait_ns.tv_sec = wait.tv_sec;
		wait_ns.tv_nsec = wait.tv_usec * 1000;
		//printf("thread 2, job no %d sleeping for %d sec %d mic seconds \n", job_no,wait.tv_sec, wait.tv_usec);
		nanosleep(&wait_ns,&wait_ns);
		gettimeofday(&start_time,NULL);
		//GetTimeStamp(&start_high, &start_low);
		if(PAPI_read(event_set, values_low_dummy) != PAPI_OK)
			printf("*******error reading*******\n ");

		for( i = 0 ; i < 3100; i ++)
		{
			for ( j = 0 ; j < (PAGES_PER_THREAD ); j ++)
			{
				thread2_alloc_list[j][0] = 2;
				asm("DMB;");
			}
			//small_blk_1[0] = 2;
			//small_blk_2[0] = 2;
        		/*insertion_sort_init(access_list[1]);
        		insertion_sort_init(access_list[2]);
        		insertion_sort_init(access_list[3]);
        		insertion_sort_init(access_list[4]);
			insertion_sort(access_list[1]);
			insertion_sort(access_list[2]);
			insertion_sort(access_list[3]);*/
        		//insertion_sort_init(access_list[4]);
			/*for ( i = 0 ; i < INSERTION_SORT_MAX_ELEMENTS; i ++)
			{
				access_list[4][i] = 2;
			}*/
			//insertion_sort(access_list[4]);
		}

		if(PAPI_read(event_set, values_low) != PAPI_OK)
			printf("*******error reading*******\n ");

		thread2_load_L1_miss_L2_miss[job_no ] = values_low[0] - values_low_dummy[0];
		thread2_load_L1_miss_L2_hit[job_no ] = values_low[1] - values_low_dummy[1];
		//thread2_store_L1_miss_L2_miss[job_no ] = values_low[2] - values_low_dummy[2];
		//thread2_store_L1_miss_L2_hit[job_no ] = values_low[3] - values_low_dummy[3];

		/*for( i = 0 ; i < ( (45 * 1023 * 9) + 20000) * 21; i ++)
		  {
		  asm("nop;");
		  }*/
		addtime(&release, &period);
		gettimeofday(&end_time, NULL);

		//GetTimeStamp(&end_high, &end_low);
		//thread2_exec_cycles[job_no] = GetNumberOfCycles(start_high, start_low,end_high,end_low,base);
		thread2_exec_cycles[job_no] = gettime(start_time, end_time);
		job_no++;
	}while(job_no <= thread2_no_of_jobs);//while(1);//while(no_of_times != 0);
	thread2_done = 1;
	asm("DMB;");
	if(PAPI_stop(event_set,values_low) != PAPI_OK)
		printf("low level stop event error\n");

}

void *bg_task(void *arg)
{
	pthread_attr_t gattr;
	CALL(pthread_getattr_np(pthread_self(), &gattr));
	display_pthread_attr(&gattr, "3");
//	while(thread1_done == 0 && thread2_done == 0);
//	while(thread2_done == 0);
	while(thread1_done == 0);
}



void find_mappings()
{
        int i = 0 , j = 0;
        long addr_mask = 0x00000003F000;

        for ( i = 0 ; i < 64; i ++)
        {
                mappings[i] = 0;
        }
	for ( i = 0 ; i < PAGES_PER_THREAD; i ++)
	{
		if( thread1_alloc_list[i] != NULL)
		{
			int color =  ( ( (long) thread1_alloc_list[i] & addr_mask) >> 12) % 64;
			mappings[color] = mappings[color] + 1;
		}
		if( thread2_alloc_list[i] != NULL)
		{
			int color =  ( ( (long) thread2_alloc_list[i] & addr_mask) >> 12) % 64;
			mappings[color] = mappings[color] + 1;	
		}
	}
}

int find_set_with_max_mappings()
{
	int i = 0 ;
	int max = -1;
	int set = -1;
	for ( i = 0 ; i < 64 ; i ++)
	{
		if(mappings[i] > max)
		{
			set = i;
			max = mappings[i];
		}
	}
	return set;
}



volatile int ** get_access_list(char * thread_name)
{
	volatile int ** alloc_list;
	volatile int ** temp_list = NULL;
	volatile int ** access_list = NULL;
	int *access_list_length = (int *) malloc(sizeof(int));
	*access_list_length = 0;
	int temp_list_idx = 0;
	 temp_list = (volatile int **) malloc(sizeof(int *) * 10);
	int i = 0;
	long addr_mask = 0x00000003F000;
	for ( i = 0 ; i < 10 ; i ++)
	{
		temp_list[i] = NULL;
	}

	volatile int maxed_set = find_set_with_max_mappings();
	//maxed_set = 2;
	if(strcmp(thread_name,"t1") == 0)
	{
		alloc_list = thread1_alloc_list;
		#ifdef TLB_MALLOC	
		//maxed_set = 3;	
		#endif
	}
	else if(strcmp(thread_name, "t2") == 0)
	{
		alloc_list = thread2_alloc_list;
		#ifdef TLB_MALLOC
		//maxed_set = 11;
		#endif
	}
	printf(" %s Maxed set %d\n",thread_name,maxed_set);
	for ( i = 0 ; i < PAGES_PER_THREAD; i ++)
	{
		int color =  ( ( ((long) alloc_list[i]) & addr_mask) >> 12) % 64;
		if(color == maxed_set)
		{
			temp_list[temp_list_idx] = alloc_list[i];
			temp_list_idx++;
		}
			
	}
	for ( i = 0 ; i < 10 ; i ++)
	{
		if(temp_list[i] != NULL)
			(*access_list_length)++;
	}
	printf("Access list length: %d\n",*access_list_length);
	access_list = (volatile int **) malloc(sizeof(int*) * (*access_list_length + 1));
	for ( i = 1 ; i <= *access_list_length; i ++)
	{
		access_list[i] = temp_list[i-1];
	}
	access_list[0] = access_list_length;
	return access_list;
}
void print_mappings()
{
	int i;
	printf("Mappings\n");
        for( i = 0 ; i < 64 ; i ++)
        {
                printf("Set no %d : %d\n", i, mappings[i]);
        }

}




int main(){

	pthread_t thread_1,thread_2, thread_3,thread_4;
	pthread_attr_t thread1_attr, thread2_attr, thread3_attr;
	int retval, rc,i;
	cpu_set_t cpu_set;
	struct sched_param param, thread1_schedparam, thread2_schedparam, thread3_schedparam;
	int small_block_size_bytes = 4092;
	param.sched_priority = 98;
	CPU_ZERO(&cpu_set);
	CPU_SET(0, &cpu_set);

	CALL(sched_setscheduler(getpid(),SCHED_FIFO,&param));
	CALL(sched_setaffinity(getpid(), sizeof(cpu_set_t), &cpu_set));
	/*if ( (retval = sched_setaffinity(getpid(), sizeof(cpu_set_t), &cpu_set)) != 0)
	  {
	  int err = errno;
	  printf("Error setting affinity for main, return code: %d\n",retval);
	  printf("Error no: %d\n",err);
	  exit(1);
	  }*/ 
	retval = PAPI_library_init( PAPI_VER_CURRENT );
	if ( retval != PAPI_VER_CURRENT ) {
		printf("PAPI LIB Init failed\n");
		exit(1);
	}
	retval = PAPI_thread_init( ( unsigned long ( * )( void ) )( pthread_self ) );
	if ( retval != PAPI_OK ) {
		printf("PAPI thread LIB init failed\n");
		exit(1);
	}


	//init mutex and condition vars
	CALL(pthread_mutex_init(&thread1_proceed_mutex, NULL));
  	CALL(pthread_cond_init (&thread1_proceed_cv, NULL));
	CALL(pthread_mutex_init(&thread2_proceed_mutex, NULL));
  	CALL(pthread_cond_init (&thread2_proceed_cv, NULL));

	//init thread 1 attributes
	CALL(pthread_attr_init( &thread1_attr ));
	CALL(pthread_attr_setinheritsched(&thread1_attr, PTHREAD_EXPLICIT_SCHED));
	CALL(pthread_attr_setschedpolicy(&thread1_attr,SCHED_FIFO));
	CALL(pthread_attr_setaffinity_np(&thread1_attr,sizeof(cpu_set_t), &cpu_set));


	//init thread 2 attributes
	CALL(pthread_attr_init( &thread2_attr ));
	CALL(pthread_attr_setinheritsched(&thread2_attr, PTHREAD_EXPLICIT_SCHED));
	CALL(pthread_attr_setschedpolicy(&thread2_attr,SCHED_FIFO));
	CALL(pthread_attr_setaffinity_np(&thread2_attr,sizeof(cpu_set_t), &cpu_set));


	//init thread 3 attributes
	CALL(pthread_attr_init( &thread3_attr ));
	CALL(pthread_attr_setinheritsched(&thread3_attr, PTHREAD_EXPLICIT_SCHED));
	CALL(pthread_attr_setschedpolicy(&thread3_attr,SCHED_FIFO));
	CALL(pthread_attr_setaffinity_np(&thread3_attr,sizeof(cpu_set_t), &cpu_set));

	//setting thread scope
	CALL(pthread_attr_setscope( &thread1_attr, PTHREAD_SCOPE_SYSTEM ));
	CALL(pthread_attr_setscope( &thread2_attr, PTHREAD_SCOPE_SYSTEM ));
	CALL(pthread_attr_setscope( &thread3_attr, PTHREAD_SCOPE_SYSTEM ));

	//setting up initial start times for both threads
	gettimeofday(&thread1_start_time, NULL);
	gettimeofday(&thread2_start_time, NULL);

	//account for initialization time and phase
	struct timeval init_time, phase;
	init_time.tv_sec = 0;
	//init_time.tv_usec = 5600;
	init_time.tv_usec = 15000+ 15000;
	phase.tv_sec = 0;
	phase.tv_usec = 1000;
	addtime(&thread1_start_time, &init_time);
	addtime(&thread1_start_time, &phase);
	//init_time.tv_usec = 470;
	addtime(&thread2_start_time, &init_time);
	struct rlimit process_rtlimit;

		init_tlb_malloc_lib(64, 2, 0, 0, 0 ,0);
	extern const int STATS_MAX_ARRAY_ELEMENTS, INSERTION_SORT_MAX_ELEMENTS;
	#ifdef NORMAL_MALLOC
		thread1_alloc_list = (volatile int **) malloc(sizeof(int *) * 375);
		thread2_alloc_list = (volatile int **) malloc(sizeof(int *) * 375);
                for ( i = 0 ; i < PAGES_PER_THREAD; i ++)
                {
                        thread1_alloc_list[i] = (int *) malloc(sizeof(int) * STATS_MAX_ARRAY_ELEMENTS);
                }
		for ( i = 0 ; i < PAGES_PER_THREAD; i ++)
                {
                        thread2_alloc_list[i] = (int *) malloc(sizeof(int) * INSERTION_SORT_MAX_ELEMENTS);
                }
		find_mappings();
		//print_mappings();
		/*printf("Thread 1 addresses\n");
        	for ( i = 0 ; i < PAGES_PER_THREAD ; i ++)
        	{
                	printf("thread1_alloc_list[%d] = %p\n", i , thread1_alloc_list[i]);
        	}*/


	#endif
	#ifdef TLB_MALLOC
		//init_tlb_malloc_lib(16, 4, 4, 8, 0 ,8);
		thread1_alloc_list = (volatile int **) tlb_malloc((sizeof(int *) * 375) , COLOR_0);
		thread2_alloc_list = (volatile int **) tlb_malloc((sizeof(int *) * 375) , COLOR_0);
		int k;
		for ( k = 0 ; k < PAGES_PER_THREAD; k ++)
		{
			thread1_alloc_list[k] = NULL;
			thread2_alloc_list[k] = NULL;
		}
	#endif
	//getrlimit(RLIMIT_RTPRIO,&process_rtlimit);
	//printf("Soft limit %d\n",process_rtlimit.rlim_cur);
	//printf("Hard limit %d\n",process_rtlimit.rlim_max);
	thread3_schedparam.sched_priority = 90; 
	CALL(pthread_attr_setschedparam(&thread3_attr, &thread3_schedparam));	
	rc = pthread_create( &thread_3, &thread3_attr, bg_task, ( void * ) 2 );

	thread1_schedparam.sched_priority = 97;
	CALL(pthread_attr_setschedparam(&thread1_attr, &thread1_schedparam));	
	rc = pthread_create( &thread_1, &thread1_attr, thread_1_access, ( void * ) 0 );

	thread2_schedparam.sched_priority = 96; 
	CALL(pthread_attr_setschedparam(&thread2_attr, &thread2_schedparam));	
	rc = pthread_create( &thread_2, &thread2_attr, thread_2_access_new, ( void * ) 1 );

	//rc = pthread_create( &thread_4, &attr, thread_1_access, ( void * ) 3 );
	/*void *stack_addr;
	  size_t stack_size;
	  if (pthread_attr_getstack(&thread1_attr, &stack_addr, &stack_size) == 0 )
	  {
	  printf("Thread 1 stack address and size %p %x\n", stack_addr, stack_size);
	  }*/


	pthread_join(thread_1, NULL);
	pthread_join(thread_2, NULL);
	pthread_join(thread_3, NULL);
	//pthread_join(thread_4, NULL);
	//find_mappings();
	//print_mappings();
	printf("Thread 1 addresses\n");
	for ( i = 0 ; i < PAGES_PER_THREAD ; i ++)
	{
		printf("thread1_alloc_list[%d] = %p\n", i , thread1_alloc_list[i]);
	}
	printf("Thread 2 addresses\n");
	for ( i = 0 ; i < PAGES_PER_THREAD ; i ++)
	{
		printf("thread2_alloc_list[%d] = %p\n", i , thread2_alloc_list[i]);
	}
	for( i = 0 ; i <= thread1_no_of_jobs; i ++)
	{
		printf("---- thread 1 Job Number %d ----\n\n" , i);
		printf("Main DTLB miss cycles: %lld\n",thread1_load_L1_miss_L2_miss[i]);
		printf("Micro DTLB miss cycles: %lld\n",thread1_load_L1_miss_L2_hit[i]);
		//printf("Store L1 miss L2 miss: %lld\n",thread1_store_L1_miss_L2_miss[i]);
		//printf("Store L1 miss L2 hit: %lld\n",thread1_store_L1_miss_L2_hit[i]);
		printf ("Time in cycles: %llu\n", thread1_exec_cycles[i]);
		printf("------------- -----\n\n");
	} 
	for( i = 0 ; i <= thread2_no_of_jobs; i ++)
	{
		printf("---- Thread 2 Job Number %d ----\n\n" , i);
		printf("Main DTLB miss cycles: %lld\n",thread2_load_L1_miss_L2_miss[i]);
		printf("Micro DTLB miss cycles: %lld\n",thread2_load_L1_miss_L2_hit[i]);
		//printf("Store L1 miss L2 miss: %lld\n",thread2_store_L1_miss_L2_miss[i]);
		//printf("Store L1 miss L2 hit: %lld\n",thread2_store_L1_miss_L2_hit[i]);
		printf ("Time in cycles: %llu\n", thread2_exec_cycles[i]);
		printf("------------- -----\n\n");
	} 
	pthread_exit(NULL);

	return 0;
}
